'' FryView v1.2 by James Hughes/Vampyre 
'' based on spudview by JEFF LEDGER/OBC
'' Video Driver by Doug Dingus
'' many thanks to baggers for help and inspiration

''This program displays .PGF (prop graphics format) images that were created
''using the .PPM to .PGF converter program which should have come in the zip
''file with this application
''
''use space bar and backspace to navigate through images, Q to quit


CON
  _CLKMODE = xtal1 + pll16x          ''''''''''''''''''''''''''''''''''''''''''''
  _XINFREQ = 5_000_000               ''  This viewer is hardcoded to display   ''
                                     ''  video using demoboard/protoboard      ''
  HORIZONTAL_PIXELS = 160            ''  settings.   Keyboard on 26.           ''
  VERTICAL_PIXELS   = 96             ''  .pgf images must be on your SD.       ''
                                     ''                                        ''
   spiDO     = 0                    ''''''''''''''''''''''''''''''''''''''''''''
   spiClk    = 1
   spiDI     = 2
   spiCS     = 3

VAR
  byte          displayb[HORIZONTAL_PIXELS * VERTICAL_PIXELS]   'allocate display buffer in RAM
                                  
  long          index             'temp offset for byte statement below

  long ioControl[2] 

  byte filename[13]  
  byte string_buffer[13]  
  byte file_count
       
OBJ
     tv   : "potatohead--hi-color-raster-variable-resolution_01_TV"
     sd   : "fsrwFemto"     
     key  : "Combokeyboard"
     
PUB start |  monkey, k

    key.start(26)
    sd.start(@ioControl)

    'blank out the display memory
    bytefill(@displayb,1,horizontal_pixels*vertical_pixels)
       
    tv.start(@displayb)  'start the tv cog & pass it the address of the bitmap
    sd.mount(spiDO,spiClk,spiDI,spiCS)

    'show the first image on the SD card
    file_count := 1
    monkey := find_file(string(".PGF"),file_count)
     if monkey < 0
       reboot

  repeat
    'open image and load into display ram
    sd.popen(monkey,"r")
    sd.pread(@displayb,HORIZONTAL_PIXELS*VERTICAL_PIXELS)  

    sd.pclose

    'now process user input
    k := key.newkey
    
    if k == " "           'space bar - show next file
      file_count++


    elseif k == $C8       ' if its a backspace go backwards
     file_count--
      if file_count < 1
        file_count := 1

    elseif k == "q" or k == "Q"
     reboot
     
    monkey := find_file(string(".PGF"),file_count)
    if monkey < 0 'error means we ran out of files so go back
      file_count--
      monkey := find_file(string(".PGF"),file_count)
      if monkey < 0  'error here means there weren't any files so reboot
        reboot

    
        'if we dind't have any errors that means we suceeded and there is a new file
        ' so just let the loop repeat

        
PRI find_file(str,num) | filenum, error, mystring
 ''returns the pointer to a string that contains the name of the file, or -1 on error

     bytefill(@filename,0,13)
     bytefill(@string_buffer,0,13)
     error := 0
     filenum := 0
     
  ' iterate directory and find file
    sd.opendir
    repeat
      error := sd.nextfile(@filename)
      if(error<0)
        return -1
        
      else  'we found a file
       
       mystring := right(@filename,4)    ' grab the last 4 letters
       if mystring > 0
         
         if match(mystring,str,4)  'is it a match?     
           filenum++                       'if so count it 

           if file_count == filenum         'is it the one we want?
            return @filename
       
PRI right(str,num) | bobcow, iii
 '' returns a pointer to a string that is the NUM most RIGHT charachters
 ''from STR , or -1 on error

  bytefill(@string_buffer,0,13)
  'now copy right NUM most chars
  bobcow := strsize(str) - num
  if bobcow<0
   return -1   'if the string isn't long enough then error

  repeat iii from bobcow to strsize(str)
   byte[@string_buffer][iii-bobcow] := byte[str][iii]

return @string_buffer
  
  
PRI match(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
return true

DAT

clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $19, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $49, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $89, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $99, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $b9, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $d9, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f  